; FuturePlayer + module .mso
; base code : $21690
; TODO: data music absolute addresses not yet fixed
InitFP_CIA:
		move.b	#1,InitCounter_220BB
		tst.b	IrqInstalled
		bmi.w	L21F30
		move.b	#-1,IrqStatus
		move.b	#0,$BFE401
		move.b	#$30,$BFE501
		lea	Ciaaname(pc),a1
		clr.l	d0
		movea.l	4.w,a6
		jsr	-$1F2(a6)	; openresource
		move.l	d0,CiaResPtr	; save ciares
		beq.w	fail		; fail
		movea.l	d0,a6
		lea	IntStruct(pc),a1	; IntStruct
		clr.l	d0
		jsr	-6(a6)		; SetIntVector
		tst.l	d0
		bne.w	fail		; fail
		move.b	#$81,$BFED01	; ICR
		move.b	#1,$BFEE01		; CRA
		move.b	#-1,IrqInstalled	; IrqInstalled
		moveq	#1,d0
		rts
* -------------------------
StopFP_CIA:
		bsr.w	StopFP
		tst.b	IrqInstalled
		bpl.w	L21F30
		move.b	#-1,IrqStatus
		lea	IntStruct(pc),a1
		clr.l	d0
		movea.l	CiaResPtr(pc),a6
		jsr	-$C(a6)
		move.b	#0,IrqInstalled
		rts

fail: ; fail
		moveq	#0,d0
		rts	
* ---------------------------------
IrqCode:
PlayFP		tst.b	IrqStatus
		bne.w	exitirq
		movem.l	d0-a6,-(sp)
		subq.b	#1,InitCounter_220BB
		bne.w	UpdFlangEnd
		move.b	b220BA(pc),InitCounter_220BB
; update channels
		lea	SCH0(pc),a0
		bsr.w	UpdSCH
		lea	SCH1(pc),a0
		bsr.w	UpdSCH
		lea	SCH2(pc),a0
		bsr.w	UpdSCH
		lea	SCH3(pc),a0
		bsr.w	UpdSCH

UpdFlangEnd:	
		lea	SCH0(pc),a0
		bsr.w	S219A2
		lea	SCH1(pc),a0
		bsr.w	S219A2
		lea	SCH2(pc),a0
		bsr.w	S219A2
		lea	SCH3(pc),a0
		bsr.w	S219A2
		movem.l	(sp)+,d0-a6

exitirq
		moveq	#1,d0
		rts
		
		moveq	#0,d0

;---------------------------
; the channel update routine
	; a2	SCH structure
	;
	;	a3 will be Instrument structure throughout
	;
UpdSCH:
		tst.b	1(a0)
		bne.w	L21F30
		clr.b	$A3(a0)
		clr.b	b220BC
		subq.b	#1,$9F(a0)
		bne.w	L21F30
		movea.l	$A4(a0),a1

L217D6:
		move.b	(a1)+,d0
		bmi.w	L2180E
		beq.w	L217E4
		move.b	d0,$9E(a0)

L217E4:
		move.b	(a1)+,d1
		bmi.w	L217FC
		move.l	a1,$A4(a0)
		move.b	d1,$9F(a0)
		move.b	d0,$A2(a0)
		move.b	d0,$A3(a0)
		rts	

L217FC:
		move.l	a1,$A4(a0)
		andi.b	#$7F,d1
		move.b	d1,$9F(a0)
		move.b	d0,$A2(a0)
		rts	

L2180E:
		subq.b	#1,b220BC
		beq.w	L2182E
		asl.b	#2,d0
		andi.w	#$FF,d0
		lea	ScodeVecTable(pc),a2
		movea.l	(a2,d0.w),a2
		move.b	(a1)+,d0
		jsr	(a2)
		bra.s	L217D6

L2182E:
		move.b	#$81,b220BC
		rts	

R21838:
		tst.w	4(a0)
		bne.w	L21956
		tst.l	(sp)+
		move.b	#$80,1(a0)
		tst.b	0(a0)
		bne.w	L21F30
		move.b	#$80,0(a0)
		move.w	$7C(a0),$DFF096
		rts	


R21860:
		movea.l	(a1)+,a2
		move.l	a2,$68(a0)
		movea.l	$C(a2),a3
		move.b	$E(a3),d0
		ext.w	d0
		lea	SCH0(pc),a4
		move.w	d0,$86(a4)
		move.b	$F(a3),d0
		ext.w	d0
		lea	SCH1(pc),a4
		move.w	d0,$86(a4)
		move.b	$10(a3),d0
		ext.w	d0
		lea	SCH2(pc),a4
		move.w	d0,$86(a4)
		move.b	$11(a3),d0
		ext.w	d0
		lea	SCH3(pc),a4
		move.w	d0,$86(a4)
		clr.w	$88(a0)
		clr.w	$8A(a0)
		clr.w	$8C(a0)
		clr.w	$8E(a0)
		clr.b	$90(a0)
		clr.b	$91(a0)
		clr.b	$92(a0)
		clr.b	$93(a0)
		clr.b	$AE(a0)
		rts	

R218D0:
		move.l	(a1)+,$70(a0)
		rts	

R218D6:
		move.l	#U224A0,$70(a0)
		clr.w	$74(a0)
		rts	

R218E4:
		move.w	(a1)+,$76(a0)
		rts	

R218EA:
		rts	

R218EC:
		move.w	4(a0),d1
		move.l	a1,6(a0,d1.w)
		addq.l	#4,6(a0,d1.w)
		cmpi.w	#$1C,d1
		beq.w	L21902
		addq.w	#4,d1

L21902:
		move.w	d1,4(a0)
		move.b	#1,$26(a0,d1.w)
R2190C		movea.l	(a1),a2
		movea.l	8(a2),a1
		rts	

R21914:
		move.w	4(a0),d1
		move.l	a1,$46(a0,d1.w)
		move.b	d0,$26(a0,d1.w)
		clr.b	$AD(a0)
		rts	

R21926:
		move.w	4(a0),d1
		subq.b	#1,$26(a0,d1.w)
		beq.w	L21936
		movea.l	$46(a0,d1.w),a1

L21936:
		rts	

R21938:
		tst.b	$AD(a0)
		bne.w	L21948
		move.w	4(a0),d1
		movea.l	$46(a0,d1.w),a1

L21948:
		rts	

R2194A:
		move.b	d0,$94(a0)
		rts	

R21950:
		move.b	d0,$95(a0)
		rts	

L21956:
		tst.w	4(a0)
		beq.w	L21962
		subq.w	#4,4(a0)

L21962:
		move.w	4(a0),d1
		movea.l	6(a0,d1.w),a1
		rts	

R2196C:
		lea	SCH0(pc),a2
		move.b	#-1,$AD(a2)
		lea	SCH1(pc),a2
		move.b	#-1,$AD(a2)
		lea	SCH2(pc),a2
		move.b	#-1,$AD(a2)
		lea	SCH3(pc),a2
		move.b	#-1,$AD(a2)
		clr.b	$AD(a0)
		rts	

; ------------------- S U B	R O U T	I N E -------------------


S219A2:
		movea.l	$78(a0),a1
		movea.l	$68(a0),a2
		move.b	0(a0),d0
		bmi.w	L21F30
		beq.w	L219FA
		movea.l	$6C(a0),a2
		tst.w	$9C(a0)
		beq.w	L219FA
		subq.w	#1,$9C(a0)
		bne.w	L219FA
		move.w	$7C(a0),$DFF096
		tst.b	1.w
		beq.w	L219E2
		move.b	#$80,0(a0)
		rts	

L219E2:
		tst.b	$A3(a0)
		bne.w	L219F2
		move.b	#1,$9C(a0)
		rts	

L219F2:
		clr.b	0(a0)
		movea.l	$68(a0),a2

L219FA:
		tst.b	$A3(a0)
		beq.w	L21A84
		move.w	$7C(a0),$DFF096
		clr.w	$74(a0)
		clr.b	$AE(a0)
		movea.l	$C(a2),a4
		clr.b	$84(a0)
		tst.b	$19(a4)
		bne.w	L21A2E
		move.b	$83(a0),d0
		cmp.b	$12(a4),d0
		bhi.w	L21A34

L21A2E:
		move.b	$12(a4),$83(a0)

L21A34:
		cmpi.b	#1,$20(a4)
		beq.w	L21A48
		clr.w	$88(a0)
		move.b	$1F(a4),$90(a0)

L21A48:
		cmpi.b	#1,$28(a4)
		beq.w	L21A5C
		clr.w	$8A(a0)
		move.b	$27(a4),$91(a0)

L21A5C:
		cmpi.b	#1,$30(a4)
		beq.w	L21A70
		clr.w	$8C(a0)
		move.b	$2F(a4),$92(a0)

L21A70:
		cmpi.b	#1,$38(a4)
		beq.w	L21A84
		clr.w	$8E(a0)
		move.b	$37(a4),$93(a0)

L21A84:
		movea.l	8(a2),a3
		tst.b	8(a3)
		beq.w	L21B04
		tst.b	$AE(a0)
		bne.w	L21AC2
		movea.l	$A(a3),a3
		lea	8(a3),a3
		tst.l	(a3)
		beq.w	L21AFA
		move.l	a3,$B8(a0)
		move.l	(a3),$B0(a0)
		move.b	4(a3),$AF(a0)
		lea	6(a3),a3
		move.l	a3,$B4(a0)
		move.b	#-1,$AE(a0)

L21AC2:
		movea.l	$B0(a0),a3
		subq.b	#1,$AF(a0)
		bne.w	L21B08
		movea.l	$B4(a0),a4
		tst.l	(a4)
		bne.w	L21ADC
		movea.l	$B8(a0),a4

L21ADC:
		move.l	(a4)+,$B0(a0)
		move.b	(a4)+,$AF(a0)
		tst.b	(a4)+
		beq.w	L21AF2
		move.l	a4,$B8(a0)
		subq.l	#6,$B8(a0)

L21AF2:
		move.l	a4,$B4(a0)
		bra.w	L21B08

L21AFA:
		lea	U22508(pc),a3
		bra.w	L21B08

L21B04:
		movea.l	$A(a3),a3

L21B08:
		clr.w	d0
		move.l	a3,d7
		move.b	$11(a3),d0
		add.b	$9E(a0),d0
		add.b	$94(a0),d0
		add.b	$95(a0),d0
		tst.w	$76(a0)
		bne.w	L21B58
		movea.l	$70(a0),a4
		move.w	$74(a0),d1
		move.b	8(a4,d1.w),d2
		cmpi.b	#$80,d2
		bne.w	L21B40
		move.b	8(a4),d2
		move.w	#-1,d1

L21B40:
		addq.w	#1,d1
		move.w	d1,$74(a0)
		add.b	d2,d0
		asl.b	#1,d0
		lea	U220E6(pc),a4
		move.w	(a4,d0.w),d1
		bra.w	L21B92

L21B58:
		asl.b	#1,d0
		lea	U220E6(pc),a4
		move.w	(a4,d0.w),d1
		move.w	$A0(a0),d2
		cmp.w	d2,d1
		bcs.w	L21B80
		add.w	$76(a0),d2
		bcs.w	L21B8E
		cmp.w	d1,d2
		bcs.w	L21B90
		bra.w	L21B8E

L21B80:
		sub.w	$76(a0),d2
		bcs.w	L21B8E
		cmp.w	d1,d2
		bhi.w	L21B90

L21B8E:
		move.w	d1,d2

L21B90:
		move.w	d2,d1

L21B92:
		move.w	d1,$A0(a0)
		movea.l	$C(a2),a4
		tst.l	$1A(a4)
		beq.w	L21BF8
		movea.l	$1A(a4),a5
		movea.l	8(a5),a6
		tst.b	$90(a0)
		beq.w	L21BBA
		subq.b	#1,$90(a0)
		bra.w	L21BF8

L21BBA:
		move.w	$88(a0),d3
		bmi.w	L21BF8
		move.b	(a6,d3.w),d0
		ext.w	d0
		tst.b	$21(a4)
		beq.w	L21BD2
		neg.w	d0

L21BD2:
		move.b	$1E(a4),d2
		asl.w	d2,d0
		add.w	d0,d1
		addq.w	#1,d3
		cmp.w	$C(a5),d3
		bcs.w	L21BF4
		clr.w	d3
		btst	#7,$20(a4)
		beq.w	L21BF4
		move.w	#-1,d3

L21BF4:
		move.w	d3,$88(a0)

L21BF8:
		tst.l	$22(a4)
		beq.w	L21C56
		movea.l	$22(a4),a5
		movea.l	8(a5),a6
		tst.b	$91(a0)
		beq.w	L21C18
		subq.b	#1,$91(a0)
		bra.w	L21C56

L21C18:
		move.w	$8A(a0),d3
		bmi.w	L21C56
		move.b	(a6,d3.w),d0
		ext.w	d0
		tst.b	$29(a4)
		beq.w	L21C30
		neg.w	d0

L21C30:
		move.b	$26(a4),d2
		asl.w	d2,d0
		add.w	d0,d1
		addq.w	#1,d3
		cmp.w	$C(a5),d3
		bcs.w	L21C52
		clr.w	d3
		btst	#7,$28(a4)
		beq.w	L21C52
		move.w	#-1,d3

L21C52:
		move.w	d3,$8A(a0)

L21C56:
		add.w	$86(a0),d1
		move.w	d1,6(a1)
		movea.l	8(a2),a3
		tst.b	8(a3)
		beq.w	L21C70
		movea.l	d7,a3
		bra.w	L21C86

L21C70:
		movea.l	$A(a3),a3
		tst.b	$A3(a0)
		bne.w	L21C86
		btst	#0,$10(a3)
		beq.w	L21D58

L21C86:
		move.l	8(a3),d2
		move.w	$C(a3),d0
		lsr.w	#1,d0
		btst	#0,$10(a3)
		beq.w	L21D52
		lsr.w	#1,d0
		movea.l	$C(a2),a4
		tst.l	$2A(a4)
		beq.w	L21CFA
		movea.l	$2A(a4),a5
		movea.l	8(a5),a6
		tst.b	$92(a0)
		beq.w	L21CC0
		subq.b	#1,$92(a0)
		bra.w	L21CFA

L21CC0:
		move.w	$8C(a0),d3
		bmi.w	L21CFA
		move.b	(a6,d3.w),d6
		move.b	$2E(a4),d4
		addq.b	#1,d4
		andi.l	#$FF,d6
		asl.w	d4,d6
		add.l	d6,d2
		addq.w	#1,d3
		cmp.w	$C(a5),d3
		bcs.w	L21CF6
		clr.w	d3
		btst	#7,$30(a4)
		beq.w	L21CF6
		move.w	#-1,d3

L21CF6:
		move.w	d3,$8C(a0)

L21CFA:
		tst.l	$32(a4)
		beq.w	L21D52
		movea.l	$32(a4),a5
		movea.l	8(a5),a6
		tst.b	$93(a0)
		beq.w	L21D18
		subq.b	#1,$93(a0)
		bra.s	L21CFA

L21D18:
		move.w	$8E(a0),d3
		bmi.w	L21D52
		move.b	(a6,d3.w),d6
		move.b	$36(a4),d4
		addq.b	#1,d4
		andi.l	#$FF,d6
		asl.w	d4,d6
		add.l	d6,d2
		addq.w	#1,d3
		cmp.w	$C(a5),d3
		bcs.w	L21D4E
		clr.w	d3
		btst	#7,$38(a4)
		beq.w	L21D4E
		move.w	#-1,d3

L21D4E:
		move.w	d3,$8E(a0)

L21D52:
		move.w	d0,4(a1)
		move.l	d2,(a1)

L21D58:
		movea.l	$C(a2),a4
		move.w	$82(a0),d0
		clr.w	d1
		move.b	8(a4),d1
		mulu.w	d1,d0
		move.w	$80(a0),d1
		mulu.w	d1,d0
		swap	d0
		lsr.b	#2,d0
		move.b	d0,8(a1)
		tst.b	$A2(a0)
		beq.w	L21D9C
		move.b	$84(a0),d1
		beq.w	L21DB0
		cmpi.b	#2,d1
		beq.w	L21E08
		bcs.w	L21DE0
		move.b	$17(a4),$83(a0)
		bra.w	L21E5C

L21D9C:
		move.b	$18(a4),d0
		sub.b	d0,$83(a0)
		bcc.w	L21E5C
		clr.b	$83(a0)
		bra.w	L21E5C

L21DB0:
		move.b	$12(a4),d0
		cmp.b	$13(a4),d0
		beq.w	L21DE0
		add.b	d0,$83(a0)
		bcs.w	L21DD0
		move.b	$83(a0),d0
		cmp.b	$13(a4),d0
		bcs.w	L21E5C

L21DD0:
		move.b	$13(a4),$83(a0)
		move.b	#1,$84(a0)
		bra.w	L21E5C

L21DE0:
		move.b	$14(a4),d0
		sub.b	d0,$83(a0)
		bcs.w	L21DF8
		move.b	$83(a0),d0
		cmp.b	$15(a4),d0
		bhi.w	L21E5C

L21DF8:
		move.b	$15(a4),$83(a0)
		move.b	#2,$84(a0)
		bra.w	L21E5C

L21E08:
		move.b	$16(a4),d0
		bmi.w	L21E34
		add.b	d0,$83(a0)
		bcs.w	L21E24
		move.b	$83(a0),d0
		cmp.b	$17(a4),d0
		bcs.w	L21E5C

L21E24:
		move.b	$17(a4),$83(a0)
		move.b	#3,$84(a0)
		bra.w	L21E5C

L21E34:
		andi.b	#$7F,d0
		sub.b	d0,$83(a0)
		bcs.w	L21E4C
		move.b	$83(a0),d0
		cmp.b	$17(a4),d0
		bhi.w	L21E5C

L21E4C:
		move.b	$17(a4),$83(a0)
		move.b	#3,$84(a0)
		bra.w	*+4

L21E5C:
		tst.b	$A3(a0)
		beq.w	L21E72
		move.w	$7E(a0),$DFF096
		clr.b	$A3(a0)
		rts	

L21E72:
		movea.l	8(a2),a3
		tst.b	8(a3)
		bne.w	L21E98
		movea.l	$A(a3),a3
		btst	#1,$10(a3)
		beq.w	L21E98
		move.w	#2,4(a1)
		move.l	#w224AC,(a1)

L21E98:
		rts	

L21E9A:
		move.b	#-1,IrqStatus
		bsr.w	StopFP
		clr.b	d0
		bsr.w	L21EBA
		moveq	#1,d0
		bsr.w	L21EBA
		moveq	#2,d0
		bsr.w	L21EBA
		moveq	#3,d0

L21EBA:
		moveq	#1,d1
		asl.w	d0,d1
		andi.w	#3,d0
		asl.w	#2,d0
		lea	PT221A8(pc),a0
		movea.l	(a0,d0.w),a1
		move.b	#$80,0(a1)
		move.b	#$80,1(a1)
		move.w	d1,$7C(a1)
		ori.w	#$8000,d1
		move.w	d1,$7E(a1)
		asl.w	#2,d0
		addi.w	#$A0,d0
		andi.l	#$FF,d0
		addi.l	#$DFF000,d0
		move.l	d0,$78(a1)
		move.l	#U224A0,$70(a1)
		move.l	#U224B0,$68(a1)
		clr.w	$76(a1)
		move.w	#$FF,$80(a1)
		move.b	#1,$9F(a1)
		clr.b	$82(a1)
		clr.w	$86(a1)
		clr.b	$94(a1)
		clr.b	$95(a1)
		nop	
		nop	

L21F30:

		rts	


; ------------ S U B	R O U T	I N E ------------------


S21F32:
		move.l	a1,-(sp)
		bsr.w	L21E9A
		bsr.w	StopFP
		movea.l	(sp)+,a1
		move.b	24(a1),d0
		andi.b	#7,d0
		bne.w	L21F4E
		move.b	#8,d0

L21F4E:
		move.b	d0,b220BA
		move.b	$19(a1),$BFE501
		move.l	8(a1),d0
		beq.w	L21F84
		movea.l	d0,a0
		move.l	8(a0),d0
		lea	SCH0(pc),a0
		move.l	d0,$A4(a0)
		move.l	d0,6(a0)
		clr.w	4(a0)
		clr.b	0(a0)
		clr.b	1(a0)

L21F84:
		move.l	$C(a1),d0
		beq.w	L21FAC
		movea.l	d0,a0
		move.l	8(a0),d0
		lea	SCH1(pc),a0
		move.l	d0,$A4(a0)
		move.l	d0,6(a0)
		clr.w	4(a0)
		clr.b	0(a0)
		clr.b	1(a0)

L21FAC:
		move.l	$10(a1),d0
		beq.w	L21FD4
		movea.l	d0,a0
		move.l	8(a0),d0
		lea	SCH2(pc),a0
		move.l	d0,$A4(a0)
		move.l	d0,6(a0)
		clr.w	4(a0)
		clr.b	0(a0)
		clr.b	1(a0)

L21FD4:
		move.l	$14(a1),d0
		beq.w	L21FFC
		movea.l	d0,a0
		move.l	8(a0),d0
		lea	SCH3(pc),a0
		move.l	d0,$A4(a0)
		move.l	d0,6(a0)
		clr.w	4(a0)
		clr.b	0(a0)
		clr.b	1(a0)

L21FFC:
		rts	


; -------------- S U B	R O U T	I N E ---------------


StopFP:
		lea	$DFF000,a0
		move.w	#$F,$96(a0)
		move.w	#$A0,d0
		bsr.w	S2202C
		move.w	#$B0,d0
		bsr.w	S2202C
		move.w	#$C0,d0
		bsr.w	S2202C
		move.w	#$D0,d0
		bsr.w	S2202C
		rts	

S2202C:
		lea	$DFF000,a0
		move.l	#w224AC,(a0,d0.w)
		move.w	#2,4(a0,d0.w)
		clr.b	8(a0,d0.w)
		clr.b	6(a0,d0.w)
		rts	

R2204A		move.l	d0,w220BE
		beq.w	L21F30

L22054:
		lea	SCH0(pc),a0
		bsr.w	UpdSCH
		lea	SCH1(pc),a0
		bsr.w	UpdSCH
		lea	SCH2(pc),a0
		bsr.w	UpdSCH
		lea	SCH3(pc),a0
		bsr.w	UpdSCH
		subq.l	#1,w220BE
		bne.s	L22054
		rts	


StartFuturePlayerCIA:
		bsr.w	InitFP_CIA
		beq.w	exitstart
StartFP
		lea	Ciaaname+$A(pc),a1
		bsr.w	S21F32
		clr.b	IrqStatus
		moveq	#1,d0

exitstart:
		rts	

R220A2:
		move.b	#-1,IrqStatus
		bsr.w	StopFP
		rts	
; --------------------------------------------------------------
val220b0:	dc.l $3540
val220b4:	dc.l $4471
IrqInstalled:	dc.b 0
IrqStatus:	dc.b 0
b220BA:		dc.b 4
InitCounter_220BB:
		dc.b 0

b220BC:		dc.b 0
		dc.b 0  
w220BE:		dc.l 0

IntStruct:	dc.l 0,0	; ln_Succ, ln_Pred
		dc.b 2,0	; ln_Type (NT_INTERRUPT), ln_Prioritiy
		dc.l IntName	; ln_Name
		dc.l IrqCode	; is_Data (GP comes here?)
		dc.l IrqCode	; is_Code		*RELOC*
IntName		dc.b 'Future Player',0
U220E6:		dc.w $1C40,$1AC0,$1940,$17D0,$1680,$1530,$1400,$12E0
		dc.w $11D0,$10D0,$FE0,$F00,$E20,$D60,$CA0,$BE8
		dc.w $B40,$A98,$A00,$970,$8E8,$868,$7F0,$780,$710
		dc.w $6B0,$650,$5F4,$5A0,$54C,$500,$4B8,$474,$434
		dc.w $3F8,$3C0,$388,$358,$328,$2FA,$2D0,$2A6,$280
		dc.w $25C,$23A,$21A,$1FC,$1E0,$1C4,$1AC,$194,$17D
		dc.w $168,$153,$140,$12E,$11D,$10D,$FE,$F0,$E2
		dc.w $D6,$CA,$BE,$B4,$AA,$A0,$97,$8F,$87,$7F
		dc.w $78,$71,$6B,$65,$5F,$5A,$55,$50,$4C,$48
		dc.w $44,$40,$3C,$39,$35,$32,$2F,$2D,$2A,$28
		dc.w $26,$24,$22,$20,$1E,$1C
PT221A8:	dc.l SCH0
		dc.l SCH1
		dc.l SCH2
		dc.l SCH3
SCH0:		ds.b 188
SCH1:		ds.b 188
SCH2:		ds.b 188
SCH3:		ds.b 180
U224A0:		ds.b 8   

		dc.l $808000  
w224AC:		dc.l 0
U224B0:		dc.l 0
		dc.l 0
		dc.l V224FA
		dc.l V224C0
V224C0		ds.l 14
		dc.w 0
V224FA		dc.l 0
		dc.l 0
		dc.w 0
		dc.l U22508
U22508:		dc.l 0
		dc.l 0
		dc.l w224AC	?
		dc.l $20002  
		dc.w	0  
ScodeVecTable:	dc.l R21838
		dc.l R21860
		dc.l R218D0
		dc.l R218D6
		dc.l R218E4
		dc.l R218EA
		dc.l R218EC
		dc.l R2190C
		dc.l R21914
		dc.l R21926
		dc.l R21938
		dc.l R2194A
		dc.l R21950
		dc.l L21956
		dc.l R2196C
Ciaaname:	dc.b	'ciaa.resource',0
CiaResPtr:	dc.l 0	; w22564

;---------------------------------------------------------
	incbin	defj.fp
